> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/guides/ios/bookmark/outline.md).

# Outline tree (iOS)

Learn how to work with an outline tree in Xamarin.iOS using a UI component or API guide. Display outlines & bookmarks, navigate through documents, and create new bookmarks programmatically. The Apryse

There are two options to working with an outline tree. First is using a UI component that provides tools to set a bookmark or display the outline. Second is an API guide to programmatically read outline items.

{% tabs %}
{% tab title="UI component" %}

## Display outlines & bookmarks in Xamarin.iOS

{% hint style="info" %}
**This tutorial only applies to Xamarin.iOS. See Xamarin.Android equivalent here .**
{% endhint %}

A document outline, or table of contents, demonstrates how the PDF document is organized and helps users see the overall picture. The [`PTOutlineViewController`](https://sdk.apryse.com/api/xamarinios/tools/api/pdftron.PDF.Controls.PTOutlineViewController.html) class shows the document outline (table of contents) that can be used to navigate through the document being viewed by a [`PTPDFViewCtrl`](https://sdk.apryse.com/api/xamarinios/tools/api/pdftron.PDF.PDFViewCtrl.html) by tapping on a bookmark item.

![](https://653871032-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgjsBtuYmcKhWOdM9VCg4%2Fuploads%2Fgit-blob-9acb375f71cdbf76d2250227df451bef01effd66%2Fa400d02a39898855332fc3a1d2b17effe42eb9a7-1242x2208.png?alt=media)

*The outline control is part of the Tools library, so make sure you have* [*added the Tools library to your project*](/xamarin/ui-customization/setup.md)*.*

## Show an outline view controller

To create a new outline view controller instance and display it from another view controller, supply a `PTPDFViewCtrl` instance to the `PTOutlineViewController` designated initializer:

{% code lineNumbers="true" %}

```csharp
var outlineViewController = new pdftron.PDF.Controls.PTOutlineViewController (mPdfViewCtrl);
outlineViewController.OutlineViewControllerOutlineSelected += (sender, e) => {
  // perform custom action
    this.DismissViewController (true, null);
};
outlineViewController.OutlineViewControllerDidCancel += (object sender, EventArgs e) => {
  this.DismissViewController (true, null);
};

var navigationController = new UINavigationController (outlineViewController);

if (UserInterfaceIdiomIsPad)
{
    navigationController.ModalPresentationStyle = UIModalPresentationStyle.Popover;
    navigationController.PopoverPresentationController.BarButtonItem = outlineButton;
}

this.PresentViewController (navigationController, true, null);
```

{% endcode %}

{% hint style="info" %}
**The outline view controller must be pushed onto a navigation controller's stack before being shown.**
{% endhint %}

{% hint style="info" %}
**Presenting on iPads:**

The outline view controller is designed to be presented in a popover on iPads. To do so, you must provide the `PTOutlineViewController`'s [`PopoverPresentationController`](https://docs.microsoft.com/en-us/dotnet/api/uikit.uipopoverpresentationcontroller) with either:

* a [`SourceRect`](https://docs.microsoft.com/en-us/dotnet/api/uikit.uipopoverpresentationcontroller.sourcerect#UIKit_UIPopoverPresentationController_SourceRect) AND
* a [`SourceView`](https://docs.microsoft.com/en-us/dotnet/api/uikit.uipopoverpresentationcontroller.sourceview#UIKit_UIPopoverPresentationController_SourceView)

OR

* a [`BarButtonItem`](https://docs.microsoft.com/en-us/dotnet/api/uikit.uipopoverpresentationcontroller.barbuttonitem#UIKit_UIPopoverPresentationController_BarButtonItem)

as in the example above.
{% endhint %}

You can set a delegate to be notified by the outline view controller when outline bookmarks are selected with the `PTOutlineViewControllerDelegate` protocol. (See the CompleteReader example for usage of an `PTOutlineViewController`.)
{% endtab %}

{% tab title="API guide" %}

## API to programmatically read, edit & create outlines / bookmarks

To navigate an outline tree and print its result.

{% code lineNumbers="true" %}

```csharp
void PrintIdent(Bookmark item)
{
  int ident = item.GetIdent() - 1;
  for (int i=0; i < ident; ++i) {
    Console.Write("  ");
  }
}
void PrintOutlineTree(Bookmark item)
{
  for (; item.IsValid(); item=item.GetNext()) {
    PrintIdent(item);
    Console.Write("{0:s}{1:s} ACTION -> ", (item.IsOpen() ? "- " : "+ "), item.GetTitle());
    if (item.HasChildren()) {
      PrintOutlineTree(item.GetFirstChild());
    }
  }
}
PDFDoc doc = new PDFDoc(filename);
Bookmark root = doc.GetFirstBookmark();
PrintOutlineTree(root);
```

{% endcode %}

[Read, add, edit PDF outlines and bookmarks](/xamarin/get-started/samples.md#bookmarks) Full code sample which illustrates how to read and edit existing outline items and create new bookmarks using the high-level API.

## About outline tree

A PDF document may display a document outline on the screen, allowing the user to navigate interactively from one part of the document to another. The outline consists of a tree-structured hierarchy of Bookmarks (sometimes called outline items), which serve as a "visual table of contents" to display the document's structure to the user.

Each Bookmark has a title that appears on screen, and an Action that specifies what happens when a user clicks on the Bookmark. The typical Action for a user-created Bookmark is to move to another location in the current document — although any Action can be specified.
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/xamarin/guides/ios/bookmark/outline.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
